#ifndef GLOBAL_H
#define GLOBAL_H

#include <cstdint>
#include <cstring>

const uint32_t SCR_WIDTH = 800;
const uint32_t SCR_HEIGHT = 600;
const std::string MODEL_PATH = "res/models/viking_room.obj";
const std::string TEXTURE_PATH = "res/textures/viking_room.png";
const int MAX_FRAMES_IN_FLIGHT = 1;

const float CAMERA_FOV    =  60.0f;
const float SENSITIVITY   =   0.1f;
const float SPEED         =   1.5f;
const float PLAYER_HEIGHT =   0.5f;
const float MAP_FLOOR     =   0.0f;
const float YAW           =   0.0f;
const float PITCH         =   0.0f;
const float ZOOM          =  45.0f;
const float ORIGINX       =   0.5f;
const float ORIGINZ       =  -0.5f;

float deltaTime = 0.0f;	// time between current frame and last frame
float lastFrame = 0.0f;

float lastX = SCR_WIDTH / 2.0f;
float lastY = SCR_HEIGHT / 2.0f;
bool firstMouse = true;

#endif
